# -!- makefile -!- ###########################################################
#
#			MicroEmacs Jasspa Distribution 1999.
#
#  System        : MicroEmacs
#  Description	 : Make file for Windows using Borland C++ Builder 3
#  Created       : Sat Jan 24 00:01:40 1998
#
#  Last Modified : <010711.1341>
#
#  Notes
#	Run "make -f win32bc.mak"      for optimised build produces ./me32.exe
#	Run "make -f win32bc.mak men"  for console support          ./men32.exe
#	Run "make -f win32bc.mak meu"  for url support              ./meu32.exe
#	Run "make -f win32bc.mak menu" for console & url support    ./menu32.exe
#	Run "make -f win32bc.mak med"  for debug build produces     ./med32.exe
#
#	Run "make -f win32bc.mak clean"      to clean source directory
#	Run "make -f win32bc.mak spotless"   to clean source directory even more
#
#  History
#
##############################################################################
#
# Borland C++ install directory (progra~1 == "Program Files")
TOOLSDIR      = c:\progra~1\borland\cbuild~1
#
# Installation Directory
INSTDIR	      = c:\emacs
INSTPROGFLAGS = 
#
# Local Definitions
RM            = - erase
RC            =	brc32
CC            =	bcc32
LD            =	tlink32
CDEBUG        =	-N -v
COPTIMISE     =	-N -O2 -DNDEBUG=1
CDEFS         = -D_WIN32 -w-par -I. -I$(TOOLSDIR)\include
LIBS          = import32.lib cw32mt.lib
LDFLAGS       = -v -L$(TOOLSDIR)\lib -Tpe -x -v
INSTALL       =	copy
#
# Rules
.SUFFIXES: .c .o .on .ou .onu .od .rc .res

.c.o:	
	$(CC) $(COPTIMISE) $(CDEFS) -o$@ -c $<
.c.on:	
	$(CC) $(COPTIMISE) $(CDEFS) -D_WINCON -o$*.on -c $<
.c.ou:	
	$(CC) $(COPTIMISE) $(CDEFS) -D_URLSUPP -o$*.ou -c $<
.c.onu:	
	$(CC) $(COPTIMISE) $(CDEFS) -D_WINCON -D_URLSUPP -o$*.onu -c $<
.c.od:	
	$(CC) $(CDEBUG) $(CDEFS) -o$*.od -c $<

.rc.res:	
	$(RC) -v -i . -i $(TOOLSDIR)\include -i $(TOOLSDIR)\include\mfc -fo $@ $< 
#
# Source files
STDHDR	= ebind.h edef.h eextrn.h efunc.h emain.h emode.h eprint.h \
	  esearch.h eskeys.h estruct.h eterm.h evar.h evers.h \
	  ebind.def efunc.def eprint.def evar.def etermcap.def emode.def eskeys.def
STDSRC	= abbrev.c basic.c bind.c buffer.c crypt.c dirlist.c display.c \
	  eval.c exec.c file.c fileio.c hilight.c history.c input.c \
	  isearch.c key.c line.c macro.c main.c narrow.c next.c osd.c \
	  print.c random.c regex.c region.c registry.c search.c spawn.c \
	  spell.c tag.c termio.c time.c undo.c window.c word.c

PLTHDR  = wintermr.h
PLTSRC  = winterm.c winprint.c
PLTRC   = me.rc
#
# Object files
STDOBJ	= $(STDSRC:.c=.o)	
PLTOBJ  = $(PLTSRC:.c=.o)
OBJ	= $(STDOBJ) $(PLTOBJ)

NSTDOBJ	= $(STDSRC:.c=.on)	
NPLTOBJ = $(PLTSRC:.c=.on)
NOBJ	= $(NSTDOBJ) $(NPLTOBJ)

USTDOBJ	= $(STDSRC:.c=.ou)	
UPLTOBJ = $(PLTSRC:.c=.ou)
UOBJ	= $(USTDOBJ) $(UPLTOBJ)

NUSTDOBJ = $(STDSRC:.c=.onu)	
NUPLTOBJ = $(PLTSRC:.c=.onu)
NUOBJ	= $(NUSTDOBJ) $(NUPLTOBJ)

DSTDOBJ	= $(STDSRC:.c=.od)	
DPLTOBJ = $(PLTSRC:.c=.od)
DOBJ	= $(DSTDOBJ) $(DPLTOBJ)

PLTRES  = $(PLTRC:.rc=.res)
#
# Targets
all: me

install: me
	$(INSTALL) $(INSTPROGFLAGS) me $(INSTDIR)
	@echo "install done"

clean:
	$(RM) me32.exe
	$(RM) med32.exe
	$(RM) men32.exe
	$(RM) meu32.exe
	$(RM) menu32.exe
	$(RM) *.o
	$(RM) *.od
	$(RM) *.on
	$(RM) *.ou
	$(RM) *.onu
	$(RM) me.aps
	$(RM) me.map
	$(RM) $(PLTRES)

spotless: clean
	$(RM) me32.opt
	$(RM) med32.opt
	$(RM) tags
	$(RM) *~

me:	me32.exe
me32.exe: $(OBJ) $(PLTRES)
	$(LD) $(LDFLAGS) -aa $(TOOLSDIR)\lib\c0w32.obj $(OBJ), $@,, $(LIBS),, $(PLTRES)
	
men:	men32.exe
men32.exe: $(NOBJ) $(PLTRES)
	$(LD) $(LDFLAGS) -ap $(TOOLSDIR)\lib\c0x32.obj $(NOBJ), $@,, $(LIBS),, $(PLTRES)
	
meu:	meu32.exe
meu32.exe: $(UOBJ) $(PLTRES)
	$(LD) $(LDFLAGS) -aa $(TOOLSDIR)\lib\c0w32.obj $(UOBJ), $@,, $(LIBS) ws2_32.lib,, $(PLTRES)
	
menu:	menu32.exe
menu32.exe: $(NUOBJ) $(PLTRES)
	$(LD) $(LDFLAGS) -ap $(TOOLSDIR)\lib\c0x32.obj $(NUOBJ), $@,, $(LIBS) ws2_32.lib,, $(PLTRES)

med:	med32.exe
med32.exe: $(DOBJ) $(PLTRES)
	$(LD) $(LDFLAGS) -aa $(TOOLSDIR)\lib\c0w32.obj $(DOBJ), $@,, $(LIBS),, $(PLTRES)
#
# Dependancies
$(STDOBJ): $(STDHDR)
$(PLTOBJ): $(STDHDR) $(PLTHDR)

$(NSTDOBJ): $(STDHDR)
$(NPLTOBJ): $(STDHDR) $(PLTHDR)

$(USTDOBJ): $(STDHDR)
$(UPLTOBJ): $(STDHDR) $(PLTHDR)

$(NUSTDOBJ): $(STDHDR)
$(NUPLTOBJ): $(STDHDR) $(PLTHDR)

$(DSTDOBJ): $(STDHDR)
$(DPLTOBJ): $(STDHDR) $(PLTHDR)

